with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_SequenceProxyPushConsumer_Hash is

   P : constant array (0 .. 3) of Natural :=
     (1, 4, 8, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 34, 24, 42);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (39, 24, 13, 8);

   G : constant array (0 .. 42) of Unsigned_8 :=
     (17, 0, 0, 14, 0, 14, 3, 0, 16, 0, 6, 0, 5, 0, 6, 0, 4, 0, 0, 1, 0, 19,
      13, 0, 0, 16, 0, 0, 0, 0, 0, 10, 0, 17, 0, 3, 12, 0, 15, 0, 0, 11, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 43;
         F2 := (F2 + Natural (T2 (K)) * J) mod 43;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 21;
   end Hash;

end CosNotifyChannelAdmin_SequenceProxyPushConsumer_Hash;
